﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    /**
     * DivisaoRecursiva
     * 
     * Podemos calcular a divisão inteira do número 
     * a (dividendo) pelo numero b (divisor) obtendo
     * o quociente (q) e o resto (r), sendo que:
     * a = (b * q) + r
     * O método de subtrações sucessivas funciona da
     * seguinte forma: 
     *   se (a >= b) {
     *     subtrai b de a
     *     calcula novamente a subtração, agora usando
     *     os valores (a-b) e b.
     *     // incrementa 1 em q (atualiza o número
     *     // de subtrações
     *     q = q + 1
     *   }
     *   caso contrário {
     *     // se a < b então o resto da divisao será r
     *   }
     * 
     * 
     */
    class DivisaoRecursiva
    {
        /**
         * divisao
         * 
         * Parâmetros:
         * @param a dividendo
         * @param b divisor
         * @param q quociente
         * @param r resto da divisão interira
         * 
         * Retorno:
         * @return void nada
         * 
         * Atualiza os valores das variáveis q e r
         * com os valores do quociente e o resto,
         * respectivamente
         * 
         */
        static void divisao(int a, int b, out int q, out int r)
        {
            q = 0; // contador de subtrações
            if (a >= b)
            {            
                // reduz o problema, através 
                // de uma subtração
                divisao(a - b, b, out q, out r);
                // atualiza o número de subtrações
                q++;
            }
            else
            {
                // a < b . Portanto, não mais possível 
                // subtrair b de a
                // então r é o resto da divisão
                r = a;
            }
        }

        static void Main(string[] args)
        {
            int a, b, q, r;
            
            Console.Write("Entre com o valor de a: ");
            a = int.Parse(Console.ReadLine());
            Console.Write("Entre com o valor de b: ");
            b = int.Parse(Console.ReadLine());
            
            // chama o método que fará a divisão
            // recebe o resultado nas variáveis
            // q e r
            divisao(a, b, out q, out r);
            
            Console.WriteLine("a={0},b={1},q={2},r={3}", a, b, q, r);

        }
    }
}
