﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace ConsoleJurosCompostos
{
    class Program
    {
        /**
         * CalcMontanteComposto
         * 
         * Parâmetros:
         * @param double 
         * @param double 
         * @param int 
         * 
         */
        public static double CalcMontanteComposto(double vlrFinanciamento, double taxaJuros, int numPrestacoes)
        {
            double vlrTotal = vlrFinanciamento*Math.Pow((1.0+(taxaJuros/100.0)),(double)numPrestacoes);
            return vlrTotal;
        }

        /**
         * GeraTabelaFinanciamento
         * 
         */
        static void GeraTabelaFinaciamento(double capital, double taxa, int meses)
        {
            double montante = 0.0;
           
            Console.WriteLine("Valor a financiar: {0,10:C2}", capital);
            Console.WriteLine("Taxa de Juros: {0,5:F2}", taxa);
            Console.WriteLine();

            Console.WriteLine("{0,-10}{1,10}{2,13}", "|------------|", "--------------|","-------------|");
            Console.WriteLine("{0,-10}{1,10}{2,13}", "| Prestacoes |", " Valor Total  |"," Parcelas    |");
            Console.WriteLine("{0,-10}{1,10}{2,13}", "|------------|", "--------------|","-------------|");

            for (int i = 1; i <= meses; i++)
            {
                montante = CalcMontanteComposto(capital, taxa, i);
                Console.WriteLine("| {0,10} | {2,12:C2} | {1,10:C2} |", i, montante, montante / i);
            }

            Console.WriteLine("{0,-10}{1,10}{2,13}", "|------------|", "--------------|", "-------------|");

            Console.WriteLine();



        }

        /**
         * GeraTabelaFinanciamentoEmArquivo
         * 
         * 
         */
        static void GeraTabelaFinaciamentoEmArquivo(double vlrFinanciamento, double taxaJuros, int meses)
        {
            double montante = 0.0;

            // Cria um FileStream, uma associação ao nome de um arquivo
            FileStream arq = new FileStream(@"c:\financiamento.txt", FileMode.Create);

            // Cria o stream de escrita. Tudo que for enviado ao stream
            // será escrito no arquivo associado. Funciona como
            // se fosse o Console
            StreamWriter arq_saida = new StreamWriter(arq);

            arq_saida.WriteLine("Valor a financiar: {0,10:C2}", vlrFinanciamento);
            arq_saida.WriteLine("Taxa de Juros: {0,5:F2}", taxaJuros);
            arq_saida.WriteLine();

            arq_saida.WriteLine("{0,-10}{1,10}{2,13}", "|------------|", "--------------|", "-------------|");
            arq_saida.WriteLine("{0,-10}{1,10}{2,13}", "| Prestacoes |", " Parcelas de  |", " Total       |");
            arq_saida.WriteLine("{0,-10}{1,10}{2,13}", "|------------|", "--------------|", "-------------|");

            // loop para geração da tabela de financiamento
            for (int i = 1; i <= meses; i++)
            {
                montante = CalcMontanteComposto(vlrFinanciamento, taxaJuros, i);
                arq_saida.WriteLine("| {0,10} | {2,12:C2} | {1,10:C2} |", i, montante, montante / i);
            }

            arq_saida.WriteLine("{0,-10}{1,10}{2,13}", "|------------|", "--------------|", "-------------|");

            arq_saida.WriteLine();

            // Fecha o arquivo (fluxo de saída)
            arq_saida.Close();

            // fecha o arquivo
            arq.Close();


        }

        static void Main(string[] args)
        {
            double juros;
            juros=CalcMontanteComposto(100, 1.0, 1);
            Console.WriteLine("juros={0}", juros);
            //GeraTabelaFinaciamento(1000, 3.0, 12);
            
            double valor = 1000.0;
            double taxa = 3.0;
            int meses = 12;
            Console.Write("Entre com o valor do financiamento: ");
            valor = double.Parse(Console.ReadLine());
            Console.Write("Entre com a taxa mensal de juros: ");
            taxa = double.Parse(Console.ReadLine());
            Console.Write("Entre com o numero de meses: ");
            meses = int.Parse(Console.ReadLine());
            GeraTabelaFinaciamentoEmArquivo(valor, taxa, meses);
        }
    }
}

