﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleEstruturaComplexa
{
    // define a estrutura que irá armazenar um 
    // ponto no plano cartesiado XY
    public struct Ponto
    {
        public double x;
        public double y;
    }

    class CalculaDistanciaPonto
    {
        /**
         * exibePonto
         * 
         * Exibe as coordenadas de um ponto
         * 
         * Parâmetros:
         *   @param p Ponto
         *   
         * Retorna:
         *   @return void nada
         *
         */
        static void exibePonto(Ponto p)
        {
            Console.WriteLine("(x,y)=({0},{1})", p.x, p.y);
        }

        /**
         * distância
         * 
         * Calcula a distância entre dois pontos
         * 
         * Parâmetros:
         *   @param p1 Ponto Localização do 1º ponto
         *   @param p2 Ponto Localização do 2º ponto
         *   
         * Retorna:
         *   @return double A distância entre p1 e p2
         *   
         */   
        static double distancia(Ponto p1, Ponto p2)
        {
            // exibe as coordenadas do primeiro ponto
            exibePonto(p1);
            // exibe as coordenadas do segundo ponto
            exibePonto(p2);
            // calcula a distância entre dois pontos
            return Math.Sqrt(
                Math.Pow(p1.x-p2.x,2)+
                Math.Pow(p2.y-p1.y,2)
            );

        }

        static void Main(string[] args)
        {
            Ponto p1; // define o ponto P1
            Ponto p2; // define o ponto P2

            // Lê do Console (teclado) como uma string e converte
            // para um número de precisão dupla (double)
            Console.Write("Entre com a coordenada x do primeiro ponto: ");
            p1.x = double.Parse(Console.ReadLine());

            Console.Write("Entre com a coordenada y do primeiro ponto: ");
            p1.y = double.Parse(Console.ReadLine());

            Console.Write("Entre com a coordenada x do segundo ponto: ");
            p2.x = double.Parse(Console.ReadLine());

            Console.Write("Entre com a coordenada y do segundo ponto: ");
            p2.y = double.Parse(Console.ReadLine());

            Console.WriteLine("Distancia entre P1 e P2: {0}", distancia(p1, p2));

        }
    }
}
